// #include <math.h>
#include "myiic.h"
#include "delay.h"       //???????
#include "usart.h"

#ifndef __BMP180_H 
#define __BMP180_H  
#include "sys.h"  
// #include "myiic.h"
//SCL -> PC12
//SDA -> PC11
#define SCL_H()  GPIO_SetBits(GPIOC, GPIO_Pin_12)
#define SCL_L()  GPIO_ResetBits(GPIOC, GPIO_Pin_12)
#define SDA_H()  GPIO_SetBits(GPIOC, GPIO_Pin_11)
#define SDA_L()  GPIO_ResetBits(GPIOC, GPIO_Pin_11)
 
#define SDA  GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_11)
#define BMP180_SlaveAddr 0xee //BMP180ַ

extern u8 BMP180_ID;

extern float True_Temp;       //????,??:?
extern float True_Press;      //????,??:Pa
extern float True_Altitude;   //????,??:m

void IIC_PortInit(void);
void IIC_Init(void);
void IIC_Start(void);
void IIC_Stop(void);
unsigned char IIC_ReceiveACK(void);
void IIC_SendACK(unsigned char ack);
unsigned char IIC_SendByte(unsigned char dat);
unsigned char IIC_ReadByte(void);
u8 BMP180_ReadOneByte(u8 ReadAddr);
short BMP180_ReadTwoByte(u8 ReadAddr);
void Write_OneByteToBMP180(u8 RegAdd, u8 Data);
void Read_CalibrationData(void);
long Get_BMP180UT(void);
long Get_BMP180UP(void);
void Convert_UncompensatedToTrue(long UT,long UP);

#endif 
