// #include "led.h"
// #include "delay.h"
// #include "sys.h"
// #include "key.h"
// #include "usart.h"
// #include "lcd.h"
// #include "touch.h"
// #include "dht11.h"
// #include "myiic.h"
// #include "BMP.h"
// #include "math.h"


// int main(void)
// {
// u8 t=0; 
// u8 temperature;
// u8 humidity;
// long UT,UP;
// delay_init(72); //??????? 
// NVIC_Configuration(); //?? NVIC ???? 2:2 ??????,2 ??????
// uart_init(9600);  //????????? 9600
// LED_Init();  //LED ?????
// LCD_Init();  //??? LCD
// KEY_Init();  //??? KEY
// IIC_PortInit();
// POINT_COLOR=RED;//???????
// LCD_ShowString(60,50,"WarShip STM32"); 
// LCD_ShowString(60,70,"DHT11  TEST"); 
// LCD_ShowString(60,90,"ATOM@ALIENTEK");
// LCD_ShowString(60,110,"2017/3/16"); 
// while(DHT11_Init())  //DHT11 ??? 
// {
// LCD_ShowString(60,130,"DHT11 Error");
// delay_ms(200);
// LCD_ShowString(60,150,"Please Check!        ");
// delay_ms(200);
// } 
// LCD_ShowString(60,130,"DHT11 OK");
// POINT_COLOR=BLUE;//???????
// LCD_ShowString(60,150,"Temp:   C"); 
// LCD_ShowString(60,170,"Humi:   %"); 
//  LCD_ShowString(60,190,"Press:      Pa"); 
// LCD_ShowString(60,210,"Temp1:   C"); 
// Read_CalibrationData(); //??BMP180?????
// while(1)
// { 
// if(t%10==0)//? 100ms ????
// { 
// DHT11_Read_Data(&temperature,&humidity); //?????? 
// 	LCD_ShowNum(100,150,temperature,2,16); //???? 
// LCD_ShowNum(100,170,humidity,2,16); //???? 
// 	printf("Temp:%d'C\r\n",temperature);
// 	printf("Hum:%d%%\r\n",humidity);
// BMP180_ID = BMP180_ReadOneByte(0xd0);
// UT=Get_BMP180UT();
// UP=Get_BMP180UP();
// Convert_UncompensatedToTrue(UT,UP);
// LCD_ShowNum(105,190,True_Press,6,16);
// LCD_ShowNum(105,210,True_Temp,2,16);	
// printf("Press:%.1fPa\r\n",True_Press);
// printf("Temp1:%.1fC\r\n\r\n",True_Temp);
// delay_ms(1000);
// } 
// delay_ms(100);
// t++;
// if(t==5)
// {
// t=0;
// LED0=!LED0;
// }
// }
// }



#include "sys.h"
#include "usart.h"		
#include "delay.h"	
#include "led.h" 
#include "key.h"	
#include "dht11.h"
 #include "myiic.h"
 #include "BMP.h"
#include "math.h"
#include "usart.h"
#include "lcd.h"
#include "includes.h"	
//Mini STM32չʵ 8
//ucos ʵ
//ԭ@ALIENTEK
//֧֣www.openedv.com

 
//ջС
#define LED_STK_SIZE     64
#define DHT11_STK_SIZE    128
#define BMP180_STK_SIZE    64
#define START_STK_SIZE   512

//ȼ
#define LED_TASK_Prio       9
#define DHT11_TASK_Prio    6
#define BMP180_TASK_Prio     2
#define START_TASK_Prio     10

//ջ
OS_STK  TASK_LED_STK[LED_STK_SIZE];
OS_STK  TASK_DHT11_STK[DHT11_STK_SIZE];
OS_STK  TASK_BMP180_STK[BMP180_STK_SIZE];
OS_STK  TASK_START_STK[START_STK_SIZE];
//
void TaskStart(void *pdata);
void TaskLed(void *pdata);
void TaskDht11(void *pdata);
void TaskBmp180(void *pdata);

//ϵͳʱú
void SysTick_Configuration(void);
void Stm32_Clock_Init(u8 );
	 
//Mini STM32ucos
//ucos2.52ں.
//ԭ@ALIENTEK
//www.openedv.com
//2010.12.15			 
int main(void)
{			 	   
	Stm32_Clock_Init(9); //ϵͳʱ
	NVIC_Configuration();
	delay_init(72);	     //ʱʼ 
	uart_init(9600);	 //ڳʼΪ9600
	LED_Init();		  	 //ʼLEDӵӲӿ  
  LCD_Init();  //??? LCD
  IIC_PortInit();
	KEY_Init();  //??? KEY
	POINT_COLOR=RED;//???????
   LCD_ShowString(60,50,"WarShip STM32"); 
   LCD_ShowString(60,70,"DHT11  TEST"); 
   LCD_ShowString(60,90,"ATOM@ALIENTEK");
   LCD_ShowString(60,110,"2017/4/22"); 
	SysTick_Configuration();
	OSInit();
	OSTaskCreate( TaskStart,	//task pointer
					(void *)0,	//parameter
					(OS_STK *)&TASK_START_STK[START_STK_SIZE-1],	//task stack top pointer
					START_TASK_Prio );	//task priority
	  OSStart();
  	return 0;	   
}

//ʼ
void TaskStart(void * pdata)
{
	pdata = pdata; 
	OS_ENTER_CRITICAL();   
	OSTaskCreate(TaskLed, (void * )0, (OS_STK *)&TASK_LED_STK[LED_STK_SIZE-1], LED_TASK_Prio);
	OSTaskCreate(TaskDht11, (void * )0, (OS_STK *)&TASK_DHT11_STK[DHT11_STK_SIZE-1], DHT11_TASK_Prio);
	OSTaskCreate(TaskBmp180, (void * )0, (OS_STK *)&TASK_BMP180_STK[BMP180_STK_SIZE-1], BMP180_TASK_Prio);
	OSTaskSuspend(START_TASK_Prio);	//suspend but not delete
	OS_EXIT_CRITICAL();
}
//1
//DS0.
void TaskLed(void *pdata)
{
	while(1)
	{
// 		LED0=!LED0;
// 		OSTimeDlyHMSM(0,0,0,500);			
		LED1=0;
		LED0=1;
		delay_ms(500);
		LED1=1;
		LED0=0;
		delay_ms(500);
		printf("1\n\n");
	}
}
//2
//DHT11ʪ.
void TaskDht11(void *pdata)
{
while(1)
{
// 		LED1=!LED1;
// 		OSTimeDlyHMSM(0,0,0,200);	
	u8 temperature;
 u8 humidity;
while(DHT11_Init())  //DHT11 ??? 
 {
LCD_ShowString(60,130,"DHT11 Error");
delay_ms(200);
LCD_ShowString(60,150,"Please Check!        ");
delay_ms(200);
} 
LCD_ShowString(60,130,"DHT11 OK");
POINT_COLOR=BLUE;//???????
DHT11_Read_Data(&temperature,&humidity); //?????? 
LCD_ShowString(60,150,"Temp:      C"); 
LCD_ShowString(60,170,"Humi:      %"); 
//DHT11_Read_Data(&temperature,&humidity); //?????? 
LCD_ShowNum(100,150,temperature,6,16); //???? 
LCD_ShowNum(100,170,humidity,6,16); //???? 
delay_ms(1000);
printf("2\n\n");

}
}

//3
//bmp180ѹ.
void TaskBmp180(void *pdata)
{
	while(1)
	{
// 		LED1=!LED1;
// 		OSTimeDlyHMSM(0,0,0,200);	
	long UT,UP;
  Read_CalibrationData(); //??BMP180?????
	 BMP180_ID = BMP180_ReadOneByte(0xd0);
   POINT_COLOR=BLUE;
	LCD_ShowString(60,190,"Press:      Pa"); 
  LCD_ShowString(60,210,"Temp1:   C"); 
  UT=Get_BMP180UT();
  UP=Get_BMP180UP();
  Convert_UncompensatedToTrue(UT,UP);
  LCD_ShowNum(105,190,True_Press,6,16);
  LCD_ShowNum(105,210,True_Temp,2,16);	
		delay_ms(1000);
		printf("3\n\n");
	}

}	  

// //ϵͳʱжϷ
// void SysTick_Handler(void)
// {
// 	OS_ENTER_CRITICAL(); /* Tell uC/OS-II that we are starting an ISR  */
//     OSIntNesting++;
//     OS_EXIT_CRITICAL();

//     OSTimeTick();        /* Call uC/OS-II's OSTimeTick()               */

//     OSIntExit();         /* Tell uC/OS-II that we are leaving the ISR  */
//}
//ϵͳʱã1msһж
void SysTick_Configuration(void)
{
 	SysTick->CTRL&=~(1<<2);//SYSTICKʹⲿʱԴ
	SysTick->CTRL|=1<<1;   //SYSTICKж
	SysTick->LOAD=9000;    //1msж
	//bit2,ѡⲿʱ  HCLK/8
 	SysTick->CTRL|=1<<0;   //SYSTICK
}

